package com.athena.reminiscence.ui.dialog

import android.app.Dialog
import android.content.res.Configuration
import android.os.Bundle
import android.view.View
import androidx.fragment.app.DialogFragment
import com.athena.reminiscence.R

class DspAnnounDialog : DialogFragment() {

    override fun onCreateDialog(savedInstanceState: Bundle?): Dialog {
        //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★DspInformDialog★")

    /*
        //呼び出し元のフラグメントを特定する(未使用)
        val frgName = parentFragmentManager.fragments[0].toString().substring(0,17)
        println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★DspInformDialog frgName=$frgName")
        println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★DspInformDialog frgName=${parentFragmentManager.fragments[0]}")
    */

        //ダイアログを開く
        val dialog = Dialog(requireActivity())
        dialog.setContentView(R.layout.dialog_dsp_information)

        //縦横の向きと機種(タブレット)を特定する
        val tablet = context?.resources?.getBoolean(R.bool.is_tablet)
        val aspect = resources.configuration.orientation // 1:縦 2:横
        val metrics = resources.displayMetrics
        val lp = dialog.window!!.attributes
        //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★DspInformDialog tablet=$tablet aspect=$aspect metrics=$metrics lp=$lp")

        //ダイアログの幅を設定する
        if ( tablet==true ) {
            lp.width = 600
            dialog.findViewById<View>(R.id.dspInformSpace).visibility = View.GONE
        }else {
            if (aspect == Configuration.ORIENTATION_PORTRAIT) { // 1:縦
                lp.width = (metrics.widthPixels * 0.9).toInt()

                //スクロール余白を消去する
                dialog.findViewById<View>(R.id.dspInformSpace).visibility = View.GONE

            } else {
                lp.width = 960 //(metrics.widthPixels * 0.55).toInt() // 0.55
                if ( metrics.density>=3.0 ) { lp.width = 1000 }
                //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★DspInformDialog★ metrics.density=${metrics.density} lp.width=${lp.width}")

                //スクロール余白を表示する
                dialog.findViewById<View>(R.id.dspInformSpace).visibility = View.VISIBLE
            }
        }
        dialog.window!!.attributes = lp


        //[閉じる]ボタンがクリックされたとき(閉じる)
        dialog.findViewById<View>(R.id.dialog_Dsp_InformClose).setOnClickListener {
            dismiss()
        }

        return dialog
    }

    override fun onStart() {
        super.onStart()

        //[閉じる]ボタンがクリックされたとき(閉じる)
        dialog?.findViewById<View>(R.id.dialog_Dsp_InformClose)?.setOnClickListener {
            dismiss()
        }
    }
}