package com.athena.reminiscence.ui.dialog

import android.annotation.SuppressLint
import androidx.fragment.app.DialogFragment
import android.app.Dialog
import android.content.res.Configuration
import android.os.Build
import android.os.Bundle
import android.view.View
import com.athena.reminiscence.R


class PermissionDialog : DialogFragment() { // ←← MainActivity

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        isCancelable = false
    }

    @SuppressLint("CutPasteId", "SuspiciousIndentation")
    override fun onCreateDialog(savedInstanceState: Bundle?): Dialog {

        //ダイアログを開く
        val dialog = Dialog(requireActivity())

        //ダイアログ名が読み書きのとき (Android 12以下) //--------------------------------------- api32以下
        if ( Build.VERSION.SDK_INT in 26..32 ) {
            dialog.setContentView(R.layout.dialog_get_accspermission)
        }
        //ダイアログ名が読み取りのとき (Android 13.0 以上) -------------------------------------- api33以上
        else if ( Build.VERSION.SDK_INT >= 33 ) {
            dialog.setContentView(R.layout.dialog_get_readpermission)
        }

        //縦横の向きと機種(タブレット)を特定する
        val tablet = context?.resources?.getBoolean(R.bool.is_tablet)
        val aspect = resources.configuration.orientation // 1:縦 2:横
        val metrics = resources.displayMetrics
        val lp = dialog.window!!.attributes
        //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★DspAnnalsDialog tablet=$tablet aspect=$aspect metrics=$metrics lp=$lp")

        //ダイアログの幅を設定する
        if ( tablet==true ) {
            lp.width = 600
            dialog.findViewById<View>(R.id.getPermissionSpace).visibility = View.GONE
        } else {
            if (aspect == Configuration.ORIENTATION_PORTRAIT) { // 1:縦
                if ( Build.VERSION.SDK_INT in 26..32 ) { //-------------------------- api32以下
                    lp.width = (metrics.widthPixels * 0.78).toInt()
                }else{ //Android 13.0 ----------------------------------------------------- api33以上
                    lp.width = (metrics.widthPixels * 0.9).toInt()
                }
            }
            else {                                              // 2:横
                lp.width = 960 //(metrics.widthPixels * 0.55).toInt() // 0.55
                if ( metrics.density>=3.0 ){ lp.width = 1000 }
                //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★DspAnnalsDialog★ metrics.density=${metrics.density} lp.width=${lp.width}")
            }
        }
        //dialog.window!!.attributes = lp

        //[OK]ボタンがクリックされたとき
        if ( Build.VERSION.SDK_INT in 26..32 ) { //---------------------------------- api32以下
            dialog.findViewById<View>(R.id.okAccsButton).setOnClickListener {
                //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★DspAnnalsDialog★ OnClickListener ★")
                dismiss()
            }
        } else if ( Build.VERSION.SDK_INT >= 33 ) { //Android 13.0 ------------------------ api33以上
            dialog.findViewById<View>(R.id.okReadButton).setOnClickListener {
                //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★DspAnnalsDialog★ OnClickListener ★")
                dismiss()
            }
        }

        return dialog
    } //fun onCreateDialog
} //PermissionDialog