package com.athena.reminiscence.ui.main


import android.annotation.SuppressLint
import android.graphics.Color
import android.os.Bundle
import android.view.LayoutInflater
import android.view.*
import android.widget.*
import androidx.core.view.MenuHost
import androidx.core.view.MenuProvider
import androidx.fragment.app.DialogFragment
import androidx.fragment.app.Fragment
import androidx.lifecycle.Lifecycle
import com.athena.reminiscence.R
import com.athena.reminiscence.annalsData
import com.athena.reminiscence.db.DatabaseHelper
import com.athena.reminiscence.reminsFile
import com.athena.reminiscence.ui.dialog.DspAnnalsDialog
import com.athena.reminiscence.ui.dialog.DspAnnounDialog
import com.athena.reminiscence.ui.dialog.SetAnnalsDialog
import java.io.File
import java.text.SimpleDateFormat
import java.util.Date

//クラスを宣言する
class FragmentDspAnnals : DialogFragment() {

    private lateinit var db: DatabaseHelper
  //private val du = DateUtility()
  //private var trns= ""
    private var pheigh = 0
    private var pwidth = 0
  //private var desp = ""
  //private var sort = ""
  //private var born = ""

    //ビューを生成するとき
    @SuppressLint("CutPasteId")
    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle? ): View? {

        //物理定数を取得する
      //val tablet = context?.resources?.getBoolean(R.bool.is_tablet)
      //val aspect = resources.configuration.orientation // 1:縦 2:横
      //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspAnnals★\n"+"★tablet=$tablet\n"+"★aspect=$aspect\n")
        pheigh = resources.displayMetrics.heightPixels
        pwidth = resources.displayMetrics.widthPixels
      //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspAnnals★\n"+"★displayMetrics=${resources.displayMetrics}\n"+"★height=$pheigh\n"+"★pwidth=$pwidth★")

        //フラグメント幅を物理サイズに合わせる
        /*if ( tablet==true ) {
            //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspAnnals★ tablet=true★" )
            //view?.findViewById<View>(R.id.dspAnnals)?.layoutParams?.width = 960
        }*/

        //全体のレイアウトを設定する
        return inflater.inflate(R.layout.fragment_dsp_annals, container,false)
    }

    //ビューの動きを設定するとき
    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)

        //引数を受け取る
      //val args = arguments?.getString("trns").toString() //未使用
      //val test = arguments?.getString("test").toString() //未使用
      //println("\nLine:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspAnnals★ arguments=$arguments args=$args★" )

        //ヘッダーの余白を消去する(ヘッダーの位置調整)
      /*if( resources.displayMetrics.density>=2.75 ) {
            //println("\nLine:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspAnnals★density=${resources.displayMetrics.density}★" )
            view.findViewById<View>(R.id.annalsDummy).visibility = View.GONE
        }*/


        /*
        //スタックに積まれた戻り先を取得する
        val frags: MutableList<Fragment> = parentFragmentManager.fragments
        val bc = frags.count()
        val nm = frags.toString().substring(1, 18)
        println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspAnnals★bc=$bc★nm=$nm★ frags=$frags★" )

        //スタックが累積したとき
        if ( bc==2 ) {

            //[年齢リスト]から復帰したとき
            if ( nm == "FragmentDspHowold" ) {

                //スタックの後方(復帰先となる[じぶん年表])を削除して元のフラグメントに復帰する = [年齢リスト]を保持できる
                parentFragmentManager.beginTransaction().remove(frags[1]).commit()
                //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspAnnals★bc=$bc★nm=$nm★ frags=$frags★")
            }

            //回転したとき = 常にFragmentDspAnnals 回転をMainActivityで検知するために何回もあり得る
            if ( nm == "FragmentDspAnnals" ) {

                //スタックの後方(復帰先となる[じぶん年表])を削除して累積を防ぐ
                parentFragmentManager.beginTransaction().remove(frags[1]).commit()
                //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspAnnals★bc=$bc★nm=$nm★ frags=$frags★")
            }

            //[年表編集]のダイアログが開いているとき
            if ( nm.substring(0, 15) == "EdtAnnalsDialog" ) {
                //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspAnnals★bc=$bc★nm=${nm.substring(0, 15)}★ frags=$frags★")

                //スタックの前方(戻り先の[ダイアログ])を削除する = ダイアログを閉じる
                parentFragmentManager.beginTransaction().remove(frags[0]).commit()
            }

            //[年齢編集]のダイアログが開いているとき
            if ( nm.substring(0, 15) == "EdtHowoldDialog" ) {
                //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspAnnals★bc=$bc★nm=${nm.substring(0, 15)}★ frags=$frags★")

                //スタックの前方(戻り先の[ダイアログ])を削除する = ダイアログを閉じる
                parentFragmentManager.beginTransaction().remove(frags[0]).commit()
            }
        }
        //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspAnnals★bc=$bc★nm=$nm★ frags=$frags★")
        */

        //プログレスバーを非表示にする
        //view.findViewById<View>(R.id.annalsProgressBar).visibility = View.INVISIBLE

        //MenuProviderを設定する
        val menuHost: MenuHost = requireActivity()
        menuHost.addMenuProvider(object : MenuProvider {

            //じぶん年表のオプション･メニューを設定する
            override fun onCreateMenu(menu: Menu, menuInflater: MenuInflater) {

                //回転による重複を避けるためにメユーをクリアする
                //menu.clear()

                //メユーを生成する
                menuInflater.inflate(R.menu.dspannalsmenu, menu)
                //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspAnnals★ onCreateOptionsMenu  ★menu=${menu} ★size=${menu.size()} ★menuItem0=${menu.getItem(0)} ★menuItem2=${menu.getItem(1)} ")
            }

            //メニューアイコンがクリックされたとき
            override fun onMenuItemSelected(menuItem: MenuItem): Boolean {
                //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspAnnals★ menuItem=$menuItem")

                when (menuItem.itemId) {

                    //[説明]アイコンのとき
                    R.id.menu_annals_help -> {
                        //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspAnnals★ menuItem=$menuItem")

                        //ヘルプ･ダイアログを開く
                        DspAnnalsDialog().show(parentFragmentManager, "helpAnnals")
                    }

                    //[案内]アイコンのとき
                    R.id.menu_annals_inform -> {

                        //案内ダイアログを開く
                        DspAnnounDialog().show(parentFragmentManager, "Information")
                    }

                    //[設定]アイコンのとき
                    R.id.menu_annals_setup -> {
                        //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspAnnals★ menuItem=$menuItem")

                        val f = SetAnnalsDialog()
                        val bundle = Bundle()
                        bundle.putString("test", "12345") //テスト:引数
                        f.arguments = bundle
                        //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspAnnals★ menuItem=$menuItem arguments=$arguments f.arguments=${f.arguments} bundle=$bundle")

                        //セットアップ･ダイアログを開く
                        f.show(parentFragmentManager, "iconSetupAnnals")
                    }
                }
                return true
            }
        }, viewLifecycleOwner, Lifecycle.State.RESUMED)

        //[年齢リスト]ボタンがクリックされたとき
        view.findViewById<TextView>(R.id.btnAnnalsToHowold).setOnClickListener {
            //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspAnnals★ btnAnnalsToHowoldClick ★★★" )
            //Toast.makeText(activity, "★[年齢リスト]ボタン★ Line=170", Toast.LENGTH_SHORT).show()

            //プログレスバーを表示する
            view.findViewById<View>(R.id.annalsProgressBar).visibility = View.VISIBLE

            //[年齢リスト]に遷移する
            moveFromDspAnnals(FragmentDspHowold(), "btnAnnalsToHowold")
        }
        //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspAnnals★\n★annalsData=$annalsData")

        //じぶん年表の表示を設定する
        setupAnnalsData()
        //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspAnnals★")

        //プログレスバーを非表示にする
        view.findViewById<View>(R.id.annalsProgressBar).visibility = View.INVISIBLE
    } //onViewCreated

//==================================================================================================

    //じぶん年表の表示を設定する
    @SuppressLint("CutPasteId", "RtlHardcoded", "SimpleDateFormat")
    private fun setupAnnalsData() {
        //println("\nLine:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspAnnals★setupAnnalsData★\n★anannalsData=$annalsData\n★")

        //dbに接続する
        db = DatabaseHelper(context)

        //年表データが読み込まれてないとき (起動したときはまだ読み込まれていない)(復元のときは生年月日)
        if ( annalsData=="" || annalsData=="restore" ) {

            //じぶん年表を読み込む
            annalsData = db.readAnnalsData()
            //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspAnnals★ annalsDataを読み込んだ\nannalsData=\n$annalsData")
        }

        //年表データが読み込めなかったとき (データが登録されていないとき)
        if ( annalsData == "" ) {
            //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspAnnals★年表データを取得できなかった★")

            //初期説明を表示するためにヘッダーを非表示にする
            if( pwidth<=1800 ) {
                (view?.findViewById<View>(R.id.annalsHeader) as ViewGroup).visibility = View.GONE
            }

            //[じぶん年表]を非表示にして初期説明を表示する
            (view?.findViewById<View>(R.id.annalsTable) as ViewGroup).visibility = View.GONE
            (view?.findViewById<View>(R.id.annIniTable) as ViewGroup).visibility = View.VISIBLE
            //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspAnnals★ 初期説明を表示した ★")

            //退避ファイルが存在しているとき
            if ( File(reminsFile).exists() ) {
                (view?.findViewById<View>(R.id.annResTable) as ViewGroup).visibility = View.VISIBLE
            }
            //退避ファイルが存在しないとき (初期表示の復元説明を表示する)
            else {
                (view?.findViewById<View>(R.id.annResTable) as ViewGroup).visibility = View.GONE
            }

            //末尾行に日付を表示する
            //view?.findViewById<TextView>(R.id.curDate)?.text = curDate
        }

        //年表データが読み込めたとき
        else {
            val row = annalsData.split("\n")
            var age = 0 //当年の年齢
            //println("\nLine:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspAnnals★annalsDataを表示する★\nrow[0]=${row[0]}\nrow[7]=${row[7]}\nrow[8]=${row[8]}\nrow.size=${row.size}\n\n")

            //初期説明を非表示にして[じぶん年表]を表示する
            (view?.findViewById<View>(R.id.annalsTable) as ViewGroup).visibility = View.VISIBLE
            (view?.findViewById<View>(R.id.annIniTable) as ViewGroup).visibility = View.GONE
            (view?.findViewById<View>(R.id.annResTable) as ViewGroup).visibility = View.GONE

            //じぶん年表の表示エリアを取得する
            val vg = view?.findViewById<View>(R.id.annalsTable) as ViewGroup

            //データの先頭から末尾まで繰り返す
            for (i in 0..99) {
                //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspAnnals★ i=$i  row[$i]=${row[i]}")

                //テーブルに行データを追加する
                layoutInflater.inflate(R.layout.row_annals, vg)

                //行データを分解する(履歴と時事の長さを調整する)
                val fld: List<String> = row[i].split("\t")
                var itmHist = fld[7]
                if ( i==0 ) {
                    itmHist += resources.getString(R.string.dmySpace)
                }
                if ( i==99 ) {
                    //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspAnnals★ i=$i fld[7]=${fld[7]}")
                    val fld7 = fld[7].split("|") //yyyy/mm/dd|白寿
                    //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspAnnals★ i=$i fld7[0]=${fld7[0]} fld7[1]=${fld7[1]}")
                    itmHist = fld7[1] //白寿
                }
                var itmEvnt = fld[8]
                //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspAnnals i=$i fld[7]=${fld[7]} itmHist=$itmHist itmHist.length=${itmHist.length} fld[8]=${fld[8]} itmEvnt=$itmEvnt★")

                //履歴と時事との長さを詰める(部分表示のため)
                if (itmHist.length > 8) { itmHist = itmHist.substring(0, 8) } //履歴
                if (itmEvnt.length > 2) { itmEvnt = itmEvnt.substring(0, 2) } //時事
                //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspAnnals i=$i fld[0]=${fld[0]} fld[1]=${fld[1]} fld[2]=${fld[2]} fld[3]=${fld[3]} fld[4]=${fld[4]} fld[5]=${fld[5]} fld[6]=${fld[6]} fld[7]=$itmHist fld[8]=$itmEvnt fld[9]=${fld[9]}★")

                //行番号を指定して行レイアウトを取得する
                val tr: TableRow = vg.getChildAt(i) as TableRow

                //行番号を指定して行データを表示する
                (tr.getChildAt(0) as Button).text = fld[1] //行番号(年齢)
                (tr.getChildAt(1) as TextView).text = fld[2] //西暦
                (tr.getChildAt(2) as TextView).text = fld[3] //和暦
                (tr.getChildAt(3) as TextView).text = fld[4] //十干
                (tr.getChildAt(4) as TextView).text = fld[5] //よみ(非表示)
                (tr.getChildAt(5) as TextView).text = fld[6] //十二支
                (tr.getChildAt(6) as TextView).text = itmHist //履歴
                (tr.getChildAt(7) as TextView).text = itmEvnt //時事
                (tr.getChildAt(8) as TextView).text = fld[9] //特記(非表示)

                //特記があるとき
                if (fld[9] != "") {

                    //時事の背景色をグレーにする
                    (tr.getChildAt(7) as TextView).setBackgroundColor(Color.parseColor("#efefef"))
                }

                //当年の年齢を保持する(スクロール位置の計算に使う)
                val curyear = SimpleDateFormat("yyyy/MM/dd").format(Date()).substring(0, 4)
                if (curyear == fld[2]) {
                    age = fld[1].toInt()
                    //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspAnnals curyear=$curyear fld[2]=${fld[2]} howold=$howold")
                }

                //行列がクリックされたとき
                annalsColumnClicked(i, fld)

            } //for
            //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspAnnals")

            //空白行を追加する(スクロールのため)
            for (i in 0..4) {
                layoutInflater.inflate(R.layout.row_dummy, vg)
            } //for

            //表示したときのスクロール位置を設定する
            val scrollView = view?.findViewById<ScrollView>(R.id.annalsDspView)
            val dpiRatio: Float = resources.displayMetrics.density * 48 //実測値による最適比率
            val setPoint: Int = (dpiRatio * age + 0).toInt() //年齢による行位置 + 行間の余白
            scrollView?.post { scrollView.scrollTo(0, setPoint) }
            //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspAnnals★ dpiRatio=$dpiRatio age=$age setPoint=$setPoint★\n")
            //println("\nLine:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspAnnals★ vg=${vg.visibility}")
        } //annalsData != ""

        //プログレスバーを非表示にする
        //requireView().findViewById<View>(R.id.annalsProgressBar).visibility = View.INVISIBLE
    } //setupAnnalsData

    //行列がクリックされたとき
    private fun annalsColumnClicked(tblRow:Int, fld:List<String>){
        //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspAnnals★ fld[0]=${fld[0]} fld[1]=${fld[1]} fld[2]=${fld[2]} fld[3]=${fld[3]} fld[4]=${fld[4]} fld[5]=${fld[5]} fld[6]=${fld[6]} fld[7]=${fld[7]} fld[8]=${fld[8]} fld[9]=${fld[9]}★")

        //表示エリアのレイアウトから行を特定する
        val vg = view?.findViewById<View>(R.id.annalsTable) as ViewGroup
        val tr: TableRow = vg.getChildAt(tblRow) as TableRow

        //行ボタンがクリックされたとき
        tr.getChildAt(0).setOnClickListener {

            //プログレスバーを表示する
            requireView().findViewById<View>(R.id.annalsProgressBar).visibility = View.VISIBLE

            //遷移先への引数を準備する
            val args = fld[0] +"\t"+ fld[1] +"\t"+ fld[2] +"\t"+ fld[3] +"\t"+ fld[4] +"\t"+ fld[5] +"\t"+ fld[6] +"\t"+ fld[7] +"\t"+ fld[8] +"\t"+ fld[9]

            //履歴編集フラグメントに遷移する
            moveFromDspAnnals(FragmentEdtAnnals(), args)
        }
    }

    //フラグメントを切り替えて指定先に遷移する
    private fun moveFromDspAnnals(moveToFragment:Fragment, args:String) {
        //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspAnnals args=$args★" )

        //引数をセットする
        val bundle = Bundle()
        bundle.putString("trns", args)
        moveToFragment.arguments = bundle
        //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspAnnals args=$args★" )

        //指定先に遷移する (年齢リスト or 年表編集)
        parentFragmentManager.beginTransaction()
          //.add(R.id.container, moveToFragment)
            .replace(R.id.container, moveToFragment)
            .commit()
    }
} // class Fragment_Dsp_Annals

