package com.athena.reminiscence.ui.main

import android.annotation.SuppressLint
import android.graphics.Color
import android.os.Bundle
import android.view.*
import android.widget.Button
import android.widget.TableRow
import android.widget.TextView
import androidx.core.view.MenuHost
import androidx.core.view.MenuProvider
import androidx.fragment.app.Fragment
import androidx.lifecycle.Lifecycle
import com.athena.reminiscence.R
import com.athena.reminiscence.db.DatabaseHelper
import com.athena.reminiscence.db.DateUtility
import com.athena.reminiscence.sharedPref
import com.athena.reminiscence.ui.dialog.DspHowoldDialog
import com.athena.reminiscence.ui.dialog.SetHowoldDialog
import java.text.SimpleDateFormat
import java.util.*


//クラスを宣言する
class FragmentDspHowold : Fragment() {

    private lateinit var db: DatabaseHelper
    private val du = DateUtility()
    private var trns= ""
  //private var pwidth = 0
  //private var desp = "" //表示モード
  //private var sort = "" //並順モード
  //private var born = "" //生年月日
    private var midx = 0 //表示モードの数値 0, 1, 2
    private var pCnt = 0 //0:past 過去の件数
    private var lCnt = 0 //1:live 現在の件数
    private var bCnt = 0 //2:both 全体の件数
    private var dCnt = 0 //選択されている表示モードの表示件数

    //ビューを生成する
    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?, savedInstanceState: Bundle? ): View? {

        //物理定数を取得する
    /*  val tablet = context?.resources?.getBoolean(R.bool.is_tablet)
        val aspect = resources.configuration.orientation // 1:縦 2:横
        val pwidth = resources.displayMetrics.widthPixels
        println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspAnnals★ pwidth=$pwidth")
    */
        //フラグメント幅を物理サイズに合わせる
    /*  if ( tablet==true ) {
            //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspHowold★ aspect=$aspect★" )
            //view?.findViewById<View>(R.id.dspHowold)?.layoutParams?.width = 960
        }
    */
        //全体のレイアウトを設定する
        return inflater.inflate(R.layout.fragment_dsp_howold,container,false)
    }

    //ビューの動きを設定する
    @SuppressLint("CutPasteId")
    override fun onViewCreated(view: View, savedInstanceState: Bundle?) {
        super.onViewCreated(view, savedInstanceState)
        //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold★")

        //引数を受け取る
        trns = arguments?.getString("trns").toString() //btnAnnalsToHowold 未使用
        //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspHowold★ trns=$trns★" )

        //ヘッダーの余白を消去する(ヘッダーの位置調整)
      /*if( resources.displayMetrics.density>=2.75 ) {
            //println("\nLine:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspAnnals★density=${resources.displayMetrics.density}★" )
            view.findViewById<View>(R.id.howoldDummy).visibility = View.GONE
        }*/

/*
        //スタックに積まれた戻り先を取得する
        val frags: MutableList<Fragment> = parentFragmentManager.fragments
        val bc = frags.count()
        //val nm = frags.toString().substring(1, 18)
        //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspHowold★bc=$bc★ frags=$frags★" )

        //スタックが累積したとき
        if ( bc==2 ) {
            val pos = frags.toString().indexOf("DspHowoldDialog")

            //ダイアログが開いているとき
            if ( pos!=-1 ) {

                //スタックの後方(戻り先の[ダイアログ])を削除する = [年齢リスト]に戻る
                parentFragmentManager.beginTransaction().remove(frags[1]).commit()

            //ダイアログが開いてないとき
            } else {

                //スタックの前方(戻り先の[じぶん年表])を削除する = [年齢リスト]に戻る
                parentFragmentManager.beginTransaction().remove(frags[0]).commit()
                //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold★bc=$bc★nm=$nm★ frags=$frags★")
            }
        }
*/
        //MenuProviderを設定する
        val menuHost: MenuHost = requireActivity()
        menuHost.addMenuProvider(object : MenuProvider {

            //年齢リストのオプション･メニューを設定する
            override fun onCreateMenu(menu: Menu, menuInflater: MenuInflater) {

                //回転による重複を避けるためにメユーをクリアする
                //menu.clear()

                //メユーを生成する
                menuInflater.inflate(R.menu.dsphowoldmenu, menu)
                //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspHowold★ onCreateOptionsMenu  ★menu=${menu} ★size=${menu.size()} ★menuItem0=${menu.getItem(0)} ★menuItem2=${menu.getItem(1)} ")
            }

            //メニューアイコンがクリックされたとき
            override fun onMenuItemSelected(menuItem: MenuItem): Boolean {
                when (menuItem.itemId) {

                    //[追加]アイコンのとき
                    R.id.menu_howold_addBttn -> {
                        //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspHowold★ menu_addBttn")

                        //プログレスバーを表示する
                        //view.findViewById<View>(R.id.howoldProgressBar).visibility = View.VISIBLE

                        //フラグメントを切り替えて指定先に遷移する
                        val moveToFragment = FragmentEdtHowold() //年齢(編集:追加)
                        moveFromDspHowold(moveToFragment, "?,,,,,,,,,,") //Seqs,recID,氏名,かな,元号,元号,開始日,終了日 ,stem,base,zodc
                    }

                    //[説明]アイコンのとき
                    R.id.menu_howold_help -> {
                        //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspHowold★ menu_help")

                        //ヘルプ･ダイアログを開く
                        DspHowoldDialog().show(parentFragmentManager, "iconHelpHowold")
                    }

                    //[設定]アイコンのとき
                    R.id.menu_howold_setup -> {

                        val f = SetHowoldDialog()
                        val bundle = Bundle()
                        bundle.putString("args", bCnt.toString()) //テスト:全体の件数
                        f.arguments = bundle

                        //セットアップ･ダイアログを開く
                        f.show(parentFragmentManager, "iconSetupHowold")
                    }
               }
                return true
            }
        }, viewLifecycleOwner, Lifecycle.State.RESUMED)

        //[じぶん年表]ボタンがクリックされたとき
        view.findViewById<TextView>(R.id.btnHowoldToAnnals).setOnClickListener {
            //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspHowold★ btnHowoldToAnnalsClick ★" )

            //プログレスバーを表示する
            view.findViewById<View>(R.id.howoldProgressBar).visibility = View.VISIBLE

            //[じぶん年表]に戻る
            moveFromDspHowold(FragmentDspAnnals(), "btnHowoldToAnnals")
        }

        //年齢データの表示を設定する
        setupHowoldData()

        //プログレスバーを非表示にする
        view.findViewById<View>(R.id.howoldProgressBar).visibility = View.INVISIBLE
        //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold★")
    } //onViewCreated

//==================================================================================================

    //年齢データの表示を設定する
    @SuppressLint("CutPasteId", "SetTextI18n", "SimpleDateFormat")
    private fun setupHowoldData() {
        //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold★")

        //ユーザー定数を取得する
      //val desp = sharedPref.getString("desp", "").toString()
        val sort = sharedPref.getString("sort", "").toString()
        //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold★desp=$desp★sort=$sort")

        //dbに接続する
        db = DatabaseHelper(context)

        //年齢データを読み込む
        val(past, live, itmString) = db.readHowoldData(sort)
        //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold★ past=$past live=$live itmString=\n$itmString")

        //表示モードごとの件数を変数に入れる
        midx = sharedPref.getString("desp", "")?.toInt()!!
        pCnt = past //0:past 過去の件数
        lCnt = live //1:live 現在の件数
        bCnt = pCnt + lCnt     //2:both 全体の件数
        val mCnt = intArrayOf(pCnt, lCnt, bCnt)
        dCnt = mCnt[midx] //選択されている表示モードごとの表示件数
        //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold★ itmInform=$itmInform pCnt=$pCnt lCnt=$lCnt bCnt=$bCnt dCnt=$dCnt midx=$midx")

        //年齢データを取得できたとき
        if ( dCnt>0 ) {

            //初期説明の表示エリアを非表示にする
            view?.findViewById<View>(R.id.howIniTable)?.visibility = View.GONE
            view?.findViewById<View>(R.id.howLowTable)?.visibility = View.GONE

            //当日の日付を数値に変換する
            val curNmbr = SimpleDateFormat("yyyy/MM/dd").format(Date()).replace("/".toRegex(), "").toInt()
            var trmDate:String
            var trmNmbr:Int

            //表示エリアのレイアウト変数を設定する
            var vg = view?.findViewById<View>(R.id.howoldTable) as ViewGroup
            var tblRow = 0 //表示リストの先頭行

            //表示リストのデータを行ごとの配列に入れる
            val row = itmString.split("\n")
            //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold★\n row[0]=${row[0]} \n itmString=$itmString")

            //データの先頭から末尾まで繰り返す
            for (i in 0..< bCnt){
                //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold i=$i tblRow=$tblRow pCnt=$pCnt lCnt=$lCnt bCnt=$bCnt dCnt=$dCnt itmName=${row[i]}")

                //行データを分解する
                val fld: List<String> = row[i].split(",")
                //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspHowold itmRcid=${fld[0]} itmName=${fld[1]} itmKana=${fld[2]} itmUpnm=${fld[3]} itmDnnm=${fld[4]} itmBegn=${fld[5]} itmTerm=${fld[6]} ★")

                //終了日を取得する
                trmDate = fld[6]
                trmNmbr = 0
                if (trmDate!="") { //比較のため数値に置き換える
                    trmNmbr = trmDate.replace("/".toRegex(), "").toInt()
                }
                //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold midx=$midx cur=$curNmbr trmDate=$trmDate trmNmbr=$trmNmbr itmRcid=${fld[0]} itmName=${fld[1]} itmKana=${fld[2]} itmUpnm=${fld[3]} itmDnnm=${fld[4]} itmBegn=${fld[5]} itmTerm=${fld[6]}★")


                //0:過去のとき
                if (midx==0 && trmNmbr>0 && trmNmbr<curNmbr) { //0:過去
                    //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold midx=$midx tblRow=$tblRow cur=$curNmbr trmDate=$trmDate trmNmbr=$trmNmbr itmRcid=${fld[0]} itmName=${fld[1]} itmKana=${fld[2]} itmUpnm=${fld[3]} itmDnnm=${fld[4]} itmBegn=${fld[5]} itmTerm=${fld[6]}★")

                    //テーブルに行を追加する
                    layoutInflater.inflate(R.layout.row_howold, vg)

                    //行番号を指定して行データを表示する
                    dspRowItem(vg, tblRow, fld)

                    //行番がクリックされたとき
                    howoldColumnClicked(tblRow, fld)

                    tblRow += 1
                } //0:過去

                //1:現在のとき
                else if (midx==1 && trmNmbr==0 ) { //1:現在
                    //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold midx=$midx tblRow=$tblRow cur=$curNmbr trmDate=$trmDate itmRcid=${fld[0]} itmName=${fld[1]} itmKana=${fld[2]} itmUpnm=${fld[3]} itmDnnm=${fld[4]} itmBegn=${fld[5]} itmTerm=${fld[6]}★")

                    //テーブルに行を追加する
                    layoutInflater.inflate(R.layout.row_howold, vg)

                    //行番号を指定して行データを表示する
                    dspRowItem(vg, tblRow, fld)

                    //行番がクリックされたとき
                    howoldColumnClicked(tblRow, fld)

                    tblRow += 1
                } //1:現在

                //2:全部のとき
                else if ( midx==2 ) { //2:全部
                    //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold midx=$midx tblRow=$tblRow cur=$curNmbr trmDate=$trmDate trmNmbr=$trmNmbr itmRcid=${fld[0]} itmName=${fld[1]} itmKana=${fld[2]} itmUpnm=${fld[3]} itmDnnm=${fld[4]} itmBegn=${fld[5]} itmTerm=${fld[6]}★")

                    //テーブルに行を追加する
                    layoutInflater.inflate(R.layout.row_howold, vg)

                    //行番号を指定して行データを表示する
                    dspRowItem(vg, tblRow, fld)

                    //行番がクリックされたとき
                    howoldColumnClicked(tblRow, fld)

                    tblRow += 1
                } //2:全部

            } //for

            //空白行を追加する(スクロールのため)
            for (i in bCnt .. (bCnt+5) ) {
                //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold tblRow=$tblRow ★")
                vg = view?.findViewById<View>(R.id.howoldTable) as ViewGroup
                layoutInflater.inflate(R.layout.row_dummy, vg)
            } //for

        } //if(dCnt>0)

        //年齢データを取得できなかったとき
        else{ //dCnt==0
            //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold★ itmInform=$itmInform pCnt=$pCnt lCnt=$lCnt bCnt=$bCnt dCnt=$dCnt midx=$midx")

            //過去と現在の両方が無いとき
            if ( pCnt==0 && lCnt==0 ){

                //年齢リストの表示エリアを非表示にする
                view?.findViewById<View>(R.id.howoldTable)?.visibility = View.GONE
                view?.findViewById<View>(R.id.howLowTable)?.visibility = View.GONE
            }

            //過去または現在の一方が無いとき
            else {
                //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold★ itmInform=$itmInform pCnt=$pCnt lCnt=$lCnt bCnt=$bCnt dCnt=$dCnt midx=$midx")

                //年齢リストの表示エリアを非表示にする
                view?.findViewById<View>(R.id.howoldTable)?.visibility = View.GONE
                view?.findViewById<View>(R.id.howIniTable)?.visibility = View.GONE

                //レコード件数の表示エリアを取得する
                val vg = view?.findViewById<View>(R.id.howLowTable) as ViewGroup
                val trPast = vg.getChildAt(1) as TableRow
                val trLive = vg.getChildAt(2) as TableRow

                //表示エリアにレコード件数を表示する
                (trPast.getChildAt(2) as TextView).text = pCnt.toString() //過去の件数
                (trLive.getChildAt(2) as TextView).text = lCnt.toString() //現在の件数

                //ゼロデータの文字色を赤に変更する
                if ( pCnt==0 ) { (trPast.getChildAt(2) as TextView).setTextColor(Color.parseColor("#dc143c")) }
                if ( lCnt==0 ) { (trLive.getChildAt(2) as TextView).setTextColor(Color.parseColor("#dc143c")) }
            }
        }

    } //setupHowOldData

    //行番号を指定して行データを表示する
    @SuppressLint("SetTextI18n")
    fun dspRowItem(vg:ViewGroup, tblRow:Int, fld:List<String>) {
        //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspHowold dspRowItem★ tblRow=$tblRow fld[0]=${fld[0]} fld[1]=${fld[1]} fld[2]=${fld[2]} fld[3]=${fld[3]} fld[4]=${fld[4]} fld[5]=${fld[5]} fld[6]=${fld[6]} ★")

        //生まれ年から干支を取得する
        val bgn = fld[5].replace("/","") //itmBegn = yyyy/mm/dd
        val zdc = db.getZodiac(bgn.substring(0,4)) // "$stem($ruby)/$zodc" 十干(よみ)/十二支
        //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold dspRowItem★ bgn=$bgn zdc=$zdc")

        //年齢を計算する
        val age = du.calcAge(fld[1], fld[5], fld[6]) //氏名(名称), 開始日, 終了日
        //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold dspRowItem★ age=$age★")

        //スピンナーの選択肢(元号)を取得する
        val iE = resources.getStringArray(R.array.spinnerItems)
        //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold dspRowItem★ iE[0]=${iE[0]} iE[1]=${iE[1]} iE[2]=${iE[2]} iE[3]=${iE[3]} iE[4]=${iE[4]} iE[5]=${iE[5]} iE[6]=${iE[6]}★")

        //行番号を指定して行レイアウトを取得する
        val tr: TableRow = vg.getChildAt(tblRow) as TableRow

        //行番号を設定する
        val nmbr: String = java.lang.String.format(Locale.getDefault(), "%d", tblRow + 1)
        (tr.getChildAt(0) as Button).text = nmbr //行番号

        //氏名を設定する
        (tr.getChildAt(1) as TextView).text = fld[1] //氏名
        if ( fld[1].length>7 ) {
            (tr.getChildAt(1) as TextView).textSize = 14.0f
        }

        //西暦のとき(開始日を表示する)
        if ( fld[3] == iE[1] ) { //元号 iE[0]= iE[1]=西暦 iE[2]=明治 iE[3]=大正 iE[4]=昭和 iE[5]=平成 iE[6]=令和
            (tr.getChildAt(2) as TextView).text = fld[5] //西暦
            //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold dspRowItem itmName=${fld[1]} itmUpnm=${fld[3]} itmBegn=${fld[5]} iE[1]=${iE[1]}★")
        }

        //和暦のとき(開始日を表示する)
        else {
            val bn = fld[5].split("/") //開始日
          //val jg = fld[3]
          //val jy = ""
            val yy = bn[0]
            val mm = bn[1]
            val dd = bn[2]

            //西暦を和暦に変換する
            val (jdx, jyx) = du.changeAnnoToJpn(yy, mm, dd, iE) // 略号,元号,和暦年,西暦年
            //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspHowold dspRowItem★ bn=$bn jdx=$jdx jyx=$jyx ")

            //和暦年が1桁のとき(空白を足して桁位置をそろえる)
            var jyy = jyx; if (jyy.length==1) { jyy = "   $jyy" }
            (tr.getChildAt(2) as TextView).text = "$jdx $jyy/$mm/$dd"
        }

        //氏名と名称とを空白の有無によって判別する
        val chkName = fld[1].replace("\\s".toRegex(), "")
        if ( fld[1].length==chkName.length ) {
            val sjz = context?.getString(R.string.bornErr).toString().substring(0,1) // "△"

            (tr.getChildAt(5) as TextView).text = sjz
        } else {

            //十二支を表示する
            val zc = zdc.split("/")
            (tr.getChildAt(3) as TextView).text = zc[0] //collapseColumns非表示 十干(よみ)
            (tr.getChildAt(4) as TextView).text = zc[1] //"$stem($ruby)/$zodc" 十二支(@color/bgray)
        }
        //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentEdtHowold dspRowItem★ fld[1]=${fld[1]} chkName=$chkName zodc[2]=${zodc[2]} ")

        //年齢を表示する
        (tr.getChildAt(6) as TextView).text = age

        //過去データ([終了日]が空でない)の表示色をグレーにする
        if (midx == 2 && fld[6] != "") { //2:全部 yyyy/mm/dd
            (tr.getChildAt(1) as TextView).setTextColor(Color.LTGRAY) //氏名
            (tr.getChildAt(2) as TextView).setTextColor(Color.LTGRAY) //開始日
            (tr.getChildAt(5) as TextView).setTextColor(Color.LTGRAY) //十二支
            (tr.getChildAt(6) as TextView).setTextColor(Color.LTGRAY) //年齢
        }
        //println("Line:" + Throwable().stackTrace[0].lineNumber + " ★FragmentDspHowold dspRowItem age=$age★")
    } //dspRowItem

    //行列がクリックされたとき
    private fun howoldColumnClicked(tblRow:Int, fld:List<String>){

        //表示エリアのレイアウトから行を特定する
        val vg = view?.findViewById<View>(R.id.howoldTable) as ViewGroup
        val tr: TableRow = vg.getChildAt(tblRow) as TableRow

        //行ボタンがクリックされたとき
        tr.getChildAt(0).setOnClickListener {

            //プログレスバーを表示する
            requireView().findViewById<View>(R.id.howoldProgressBar).visibility = View.VISIBLE

            //行データを取得する
            val iSeq = (tr.getChildAt(0) as Button).text.toString()
            val stem = (tr.getChildAt(3) as TextView).text
            val ruby = (tr.getChildAt(4) as TextView).text
            val zodc = (tr.getChildAt(5) as TextView).text
            //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspHowold★ howoldColumnClicked★ iSeq=$iSeq fld[0]=${fld[0]} fld[1]=${fld[1]} fld[2]=${fld[2]} fld[3]=${fld[3]} fld[4]=${fld[4]} fld[5]=${fld[5]} fld[6]=${fld[6]} stem=$stem ruby=$ruby zodc=$zodc★")

            //遷移先への引数を準備する
            val args = iSeq +","+ fld[0] +","+ fld[1] +","+ fld[2] +","+ fld[3] +","+ fld[4] +","+ fld[5] +","+ fld[6] +","+ "$stem($ruby)/$zodc"
            //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspHowold★ howoldColumnClicked★ args=$args★")

            //年齢編集フラグメントに遷移する
            moveFromDspHowold(FragmentEdtHowold(), args)
        }
    }

    //フラグメントを切り替えて指定先に遷移する
    fun moveFromDspHowold(moveToFragment:Fragment, args:String) {
        //println("Line:"+ Throwable().stackTrace[0].lineNumber +" ★FragmentDspHowold args=$args★" )

        //引数をセットする
        val bundle = Bundle()
        bundle.putString("trns", args)
        moveToFragment.arguments = bundle

        //フラグメントを切り替える
        parentFragmentManager.beginTransaction()
          //.add(R.id.container, moveToFragment)
            .replace(R.id.container, moveToFragment)
            .commit()
    }

} //class Fragment_Dsp_HowOld